searchNodes=[{"doc":"","ref":"Mix.Tasks.SharedSettings.CreateKey.html","title":"Mix.Tasks.SharedSettings.CreateKey","type":"task"},{"doc":"Returns a key for encrypting settings","ref":"Mix.Tasks.SharedSettings.CreateKey.html#run/1","title":"Mix.Tasks.SharedSettings.CreateKey.run/1","type":"function"},{"doc":"SharedSettings is a library for fetching and updating settings at runtime.The goal of this is to provide a simple, language-agnostic storage interface as well as an accompanying Ruby gem (TODO) and UI. This is not intended to be a fully-fledged feature flagging library (see FunWithFlags if you need that). Instead, this is geared toward updating settings represented by a string, integer, etc., for the purpose of easing runtime tweaking of knobs.","ref":"SharedSettings.html","title":"SharedSettings","type":"module"},{"doc":"Deletes a setting by name from cache and storage.Argumentsname - An atom representing the name of the setting to deleteReturnsIf the setting was deleted :ok is returned.This method returns :ok if the setting wasn't found so it's safe to match on :ok","ref":"SharedSettings.html#delete/1","title":"SharedSettings.delete/1","type":"function"},{"doc":"Checks whether a given setting existsArgumentsname - An atom or string representing the name of the setting to checkReturnsReturns a boolean based on if the setting was found.This uses the same logic as get so cache is hit first","ref":"SharedSettings.html#exists?/1","title":"SharedSettings.exists?/1","type":"function"},{"doc":"Fetches a setting by name.Fetches from cache first and falls back to storage if a setting isn't found/is expired.Argumentsname - An atom or string representing the name of the setting to fetchReturnsIf a setting is found, returns a tuple of :ok and the stored valueIf a setting is not found, returns {:error, :not_found}If there is an error with the storage adaptor that error is passed straight though as {:error, any()}","ref":"SharedSettings.html#get/1","title":"SharedSettings.get/1","type":"function"},{"doc":"Fetches all stored settings.This method differs from others in the fact that:The cache isn't hit, only the source of truth (ie: the store)The raw Setting.t() is returned instead of the final re-hydrated value (save for decryption)Both of these changes come from the fact that this is meant to feed the UI. The reason it's exposed on the main module is that there's a secondary personal usecase for setting presence validation on app boot.Since this is hitting the store directly thought should be put into if/how frequently this is calledReturnsIf successful (even if no settings are found), returns {:ok, [Setting.t()]}If there is an error with the storage adaptor that error is passed straight though as {:error, any()}","ref":"SharedSettings.html#get_all/0","title":"SharedSettings.get_all/0","type":"function"},{"doc":"Creates or updates a setting.Settings are unique by name and creating a second setting with the same name will overwrite the original.Argumentsname - An atom or string representing the name of the setting. Used for fetching/deletingvalue - Any data of type string, number, boolean, or rangeReturnsIf a setting is successfully stored, a tuple of :ok and the setting name as a string is returned.If value's type isn't supported, {:error, :unsupported_type} is returnedAny other failures (say, from the storage adaptor) will be returned as-is. Failures to write to cache will not be returned as an error so long as writing to storage succeeds.","ref":"SharedSettings.html#put/3","title":"SharedSettings.put/3","type":"function"},{"doc":"","ref":"SharedSettings.html#t:setting_name/0","title":"SharedSettings.setting_name/0","type":"type"},{"doc":"A behaviour module for cache adaptersSee SharedSettings.Store for more","ref":"SharedSettings.Cache.html","title":"SharedSettings.Cache","type":"behaviour"},{"doc":"Deletes a setting, identified by name.","ref":"SharedSettings.Cache.html#c:delete/1","title":"SharedSettings.Cache.delete/1","type":"callback"},{"doc":"Retrieves a setting by name.","ref":"SharedSettings.Cache.html#c:get/1","title":"SharedSettings.Cache.get/1","type":"callback"},{"doc":"Persists a setting","ref":"SharedSettings.Cache.html#c:put/1","title":"SharedSettings.Cache.put/1","type":"callback"},{"doc":"A behaviour module for persistent store adaptersAll data values are represented by strings (similar to Redis). This means that, regardless of what adaptor is being implemented, all adaptors must accept and return data in the format which we will outline.Storage adaptors are only responsible for storing the setting as-given and returning it in the expected format. Here is a list of formats and their string representation:number: &quot;1234&quot; string: &quot;any string&quot; boolean: &quot;1&quot; or &quot;0&quot; range: &quot;low,high&quot;. eg: &quot;1,5&quot; inclusive","ref":"SharedSettings.Store.html","title":"SharedSettings.Store","type":"behaviour"},{"doc":"Deletes a setting, identified by name.","ref":"SharedSettings.Store.html#c:delete/1","title":"SharedSettings.Store.delete/1","type":"callback"},{"doc":"Retrieves a setting by name.","ref":"SharedSettings.Store.html#c:get/1","title":"SharedSettings.Store.get/1","type":"callback"},{"doc":"Retrieves all settings","ref":"SharedSettings.Store.html#c:get_all/0","title":"SharedSettings.Store.get_all/0","type":"callback"},{"doc":"Persists a setting","ref":"SharedSettings.Store.html#c:put/1","title":"SharedSettings.Store.put/1","type":"callback"}]